﻿// Copyright (c) 2020 Tudor Stanciu

using AutoMapper;
using dto = Tuitio.PublishedLanguage.Dto;
using models = Tuitio.Domain.Models;

namespace Tuitio.Application.Mappings
{
    public class MappingProfile : Profile
    {
        public MappingProfile()
        {
            CreateMap<models.RecordIdentifier, dto.RecordIdentifier>();
            
            CreateMap<models.TokenExtension, dto.AuthorizationResult>()
                .ForMember(z => z.TokenId, src => src.MapFrom(z => z.Token.TokenId))
                .ForMember(z => z.UserId, src => src.MapFrom(z => z.Token.UserId))
                .ForMember(z => z.UserName, src => src.MapFrom(z => z.Token.UserName))
                .ForMember(z => z.FirstName, src => src.MapFrom(z => z.Token.FirstName))
                .ForMember(z => z.LastName, src => src.MapFrom(z => z.Token.LastName))
                .ForMember(z => z.Email, src => src.MapFrom(z => z.Token.Email))
                .ForMember(z => z.SecurityStamp, src => src.MapFrom(z => z.Token.SecurityStamp))
                .ForMember(z => z.LockStamp, src => src.MapFrom(z => z.Token.LockStamp))
                .ForMember(z => z.CreatedAt, src => src.MapFrom(z => z.Token.CreatedAt))
                .ForMember(z => z.ExpiresIn, src => src.MapFrom(z => z.Token.ExpiresIn))
                .ForMember(z => z.Claims, src => src.MapFrom(z => z.Token.Claims))
                ;

            CreateMap<models.Account.LogoutResult, dto.AccountLogoutResult>();
        }
    }
}
