﻿// Copyright (c) 2020 Tudor Stanciu

using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;
using Tuitio.Domain.Entities;

namespace Tuitio.Domain.Data.EntityTypeConfiguration
{
    class UserGroupXUserRoleConfiguration : IEntityTypeConfiguration<UserGroupXUserRole>
    {
        public void Configure(EntityTypeBuilder<UserGroupXUserRole> builder)
        {
            builder.ToTable("UserGroupXUserRole").HasKey(z => new { z.UserGroupId, z.UserRoleId });
            builder.HasOne(z => z.UserRole).WithMany().HasForeignKey(z => z.UserRoleId);
        }
    }
}
