﻿// Copyright (c) 2020 Tudor Stanciu

using Microsoft.AspNetCore.Http;
using System.Linq;
using System;
using Tuitio.Application.Abstractions;
using System.Security.Claims;

namespace Tuitio.Authentication
{
    public class HttpContextService : IHttpContextService
    {
        private readonly IHttpContextAccessor _httpAccessor;

        public HttpContextService(IHttpContextAccessor httpAccessor)
        {
            _httpAccessor=httpAccessor;
        }

        public int GetUserId()
        {
            var userIdString = _httpAccessor.HttpContext.User?.Claims.FirstOrDefault(z => z.Type == ClaimTypes.NameIdentifier)?.Value;

            if (string.IsNullOrEmpty(userIdString))
                throw new Exception("User id could not be retrieved from claims.");

            if (!int.TryParse(userIdString, out int userId))
                throw new Exception("User id is not a valid integer.");

            return userId;
        }
    }
}
